var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var globalseed = ~~0;
var tseed = ~~0;
var gen2 = ~~2147483643;
var gen1 = ~~(gen2 / 2);
function rng(min, max) {
    tseed = ~~(gen1 * tseed * 5 + gen2 + (tseed / 5) * 3);
    if (tseed < 0)
        tseed = ~~(-tseed);
    var ret = (tseed >>> 8) % (1 + max - min);
    ret += min;
    return ret;
}
function rngf() {
    return rng(0, 1000000) / 1000000;
}
function rngfn() {
    return rngf() * 2.0 - 1.0;
}
function rngexp(origmin, origmax, curve) {
    var min = origmin;
    var max = origmax;
    if (min != 0)
        min = Math.pow(min, (1 / curve));
    max = Math.pow((max + 1), (1 / curve));
    var frange = max - min;
    var f = rngf() * frange + min;
    f = Math.pow(f, curve);
    f = clamp(f, origmin, origmax);
    return f;
}
function rng_bool() {
    rng(0, 1);
    return (tseed >>> 15) & 1;
}
function clamp(number, min, max) {
    return Math.max(min, Math.min(number, max));
}
function GetDifficultyCurve(d) {
    if (d == 0)
        return 0.5;
    var dist = Math.abs(settings.difficulty - d);
    return 1 - (dist / (dist + 1));
}
function RngBoolWithDifficulty(d) {
    var val = rng(0, 100000);
    var mid = 50000;
    if (d == 0)
        return val < mid;
    var adjust = GetDifficultyCurve(d);
    adjust = adjust * 2;
    mid *= adjust;
    return val < mid;
}
function setGlobalSeed(newSeed) {
    info('setGlobalSeed from ' + globalseed + ' to ' + newSeed);
    globalseed = ~~newSeed;
    tseed = ~~newSeed;
}
function setSeed(newSeed) {
    tseed = ~~newSeed;
}
function setLocalSeed(name) {
    setSeed(globalseed + crc32(name));
}
function randomize(value, difficulty) {
    var min = 100.0;
    var max = settings.rando_range * 100.0;
    var ret = rng(min, max) / 100.0;
    if (rng_bool())
        ret = 1 / ret;
    var difficulty_curve = GetDifficultyCurve(difficulty) * 2;
    ret *= value * difficulty_curve;
    return ret;
}
var crcTable = makeCRCTable();
function makeCRCTable() {
    var c;
    var crcTable = [];
    for (var n = 0; n < 256; n++) {
        c = n;
        for (var k = 0; k < 8; k++) {
            c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
        }
        crcTable[n] = c;
    }
    return crcTable;
}
function crc32(str) {
    var crc = 0 ^ (-1);
    for (var i = 0; i < str.length; i++) {
        crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
    }
    return (crc ^ (-1)) >>> 0;
}
;
function DeepCopy(o) {
    return JSON.parse(JSON.stringify(o));
}
function runNextTick(func) {
    var sub = context.subscribe('interval.tick', function (args) {
        try {
            func();
        }
        catch (e) {
            printException('error in runNextTick', e);
        }
        sub.dispose();
    });
}
function ifPaused(whenPaused, whenUnpaused) {
    var wasPaused = { wasPaused: undefined };
    var oldElapsed = date.ticksElapsed;
    context.setTimeout(function () {
        if (date.ticksElapsed == oldElapsed) {
            wasPaused.wasPaused = true;
            if (whenPaused)
                whenPaused();
        }
        else {
            wasPaused.wasPaused = false;
            if (whenUnpaused)
                whenUnpaused();
        }
    }, 100);
    return wasPaused;
}
function PauseGame() {
    return ifPaused(null, function () { context.executeAction('pausetoggle', {}); });
}
function UnpauseGame() {
    return ifPaused(function () { context.executeAction('pausetoggle', {}); }, null);
}
function printException(msg, e) {
    info('===========\nERROR:');
    try {
        info(e.stack);
        info(msg, e.name, e.message);
    }
    catch (e2) {
        info('error in printException', msg, e, e2);
        info('types: ', msg.constructor.name, e.constructor.name, e2.constructor.name);
    }
    info('===========');
}
var MONTHS = ["February", "March", "April", "May", "June", "July", "August", "September", "October"];
function formatDate(day, month, year) {
    return "".concat(MONTHS[month], " ").concat(day, ", Year ").concat(year);
}
function loadedGame(savedData) {
    setGlobalSeed(savedData.seed);
    info("restored saved seed " + globalseed, JSON.stringify(savedData));
    for (var k in savedData) {
        settings[k] = savedData[k];
    }
    initMenuItems();
    if (global_settings.enabled === false) {
        return;
    }
    global_settings.enabled = true;
    createChangesWindow();
    AnyEntry();
}
function newGame() {
    var nextSeed = context.sharedStorage.get('RCTRando.nextSeed');
    info("nextSeed was", nextSeed);
    if (nextSeed) {
        setGlobalSeed(nextSeed);
    }
    else {
        setGlobalSeed(context.getRandom(1, 999999 + 1));
        if (global_settings.reuse_seed && global_settings.last_used_settings['seed']) {
            setGlobalSeed(global_settings.last_used_settings['seed']);
        }
    }
    context.sharedStorage.set("RCTRando.nextSeed", null);
    if (global_settings.enabled === false) {
        initMenuItems();
        return;
    }
    global_settings.enabled = true;
    if (global_settings.reuse_settings) {
        var last = DeepCopy(global_settings.last_used_settings);
        for (var k in last) {
            if (k === 'seed' || k === 'rando_version' || k === 'version' || k === 'changes')
                continue;
            settings[k] = last[k];
        }
    }
    startGameGui();
}
function SaveGlobalSettings() {
    context.sharedStorage.set('RCTRando.global_settings', global_settings);
}
function EnableDisableRando(enabled) {
    global_settings.enabled = enabled;
    info(global_settings.enabled ? 'Enabling' : 'Disabling');
    SaveGlobalSettings();
    if (global_settings.enabled) {
        main();
    }
    else {
        UnSubscribeEvents();
    }
}
function EnableDisableAutoPause(enabled) {
    global_settings.auto_pause = enabled;
    SaveGlobalSettings();
}
function EnableDisableReuseSeed(enabled) {
    global_settings.reuse_seed = enabled;
    SaveGlobalSettings();
}
function initRando() {
    global_settings.last_used_settings = DeepCopy(settings);
    global_settings.last_used_settings['seed'] = globalseed;
    SaveGlobalSettings();
    SaveSettings();
    info(rando_name + ' v' + rando_version
        + ' starting with seed ' + globalseed
        + ', api version ' + context.apiVersion
        + ', difficulty: ' + settings.difficulty
        + ', scenarioLength: ' + settings.scenarioLength);
    try {
        FirstEntry();
    }
    catch (e) {
        printException('error in initRando(): ', e);
    }
}
function SaveSettings() {
    try {
        settings['rando_version'] = rando_version;
        settings['seed'] = globalseed;
        context.getParkStorage().set('RCTRando.settings', settings);
        debug('just saved data', JSON.stringify(settings));
    }
    catch (e) {
        printException('error saving settings: ', e);
    }
}
var rando_name = 'RollerCoaster Tycoon Randomizer';
var rando_version = '0.9.1 Alpha';
var bDebug = false;
function debug(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    if (bDebug)
        console.log(message, optionalParams);
}
function info(message) {
    var optionalParams = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        optionalParams[_i - 1] = arguments[_i];
    }
    console.log(message, optionalParams);
}
var global_settings = {
    rando_version: rando_version,
    enabled: true,
    auto_pause: true,
    reuse_seed: false,
    reuse_settings: true,
    last_used_settings: {}
};
var initedMenuItems = false;
var subscriptions = [];
var minApiVersion = 52;
var targetApiVersion = 70;
info("              \n" + rando_name + " v" + rando_version
    + ", OpenRCT2 API version " + context.apiVersion + ', minimum required API version is ' + minApiVersion + ', recommended API version is ' + targetApiVersion
    + ', network.mode: ' + network.mode + ', context.mode: ' + context.mode);
if (context.apiVersion < targetApiVersion && typeof ui !== 'undefined') {
    ui.showError('You need to update OpenRCT2', 'for RCTRandomizer!');
}
function main() {
    try {
        if (context.mode != 'normal') {
            return;
        }
        if (network.mode == 'client') {
            info(network.mode);
            var savedData = context.getParkStorage().get('RCTRando.settings');
            if (savedData && savedData.hasOwnProperty('seed')) {
                runNextTick(_main);
            }
            else {
                info('ERROR: savedData not found, you probably joined the game before RCT Randomizer initialized!');
            }
            return;
        }
        runNextTick(_main);
    }
    catch (e) {
        printException('error in _main', e);
    }
}
registerPlugin({
    name: rando_name,
    version: rando_version,
    authors: ['Die4Ever'],
    type: 'remote',
    licence: "GPL-3.0",
    targetApiVersion: targetApiVersion,
    minApiVersion: minApiVersion,
    main: main
});
var difficulties = { 'Very Easy': -0.7, Easy: -0.4, Medium: -0.1, Hard: 0.2, Extreme: 0.4 };
var scenarioLengths = { Speedrun: 0.2, Random: 0, Normal: 1, Long: 2, Marathon: 3 };
var randoRanges = { Low: 1.3, Medium: 1.5, High: 2, Extreme: 3 };
var randoCycles = { Never: 0, Infrequent: 80, 'Semi-Frequent': 40, Frequent: 24, 'Very Frequent': 16, 'Extremely Frequent': 8 };
var settings = {
    rando_version: rando_version,
    rando_range: randoRanges.Medium,
    difficulty: difficulties.Easy,
    scenarioLength: scenarioLengths.Random,
    num_months_cycle: randoCycles.Infrequent,
    cycle_offset: 0,
    rando_ride_types: true,
    rando_park_flags: true,
    rando_park_values: true,
    rando_goals: true,
    rando_scouting: true,
    rando_crowdcontrol: false
};
function _main() {
    var savedData;
    if (bDebug)
        run_tests();
    try {
        var temp_global_settings = context.sharedStorage.get('RCTRando.global_settings', global_settings);
        if (temp_global_settings['rando_version'] == rando_version) {
            for (var k in temp_global_settings) {
                global_settings[k] = temp_global_settings[k];
            }
        }
    }
    catch (e) {
        printException('error loading global_settings: ', e);
    }
    info(rando_name + " v" + rando_version + " starting, network.mode: " + network.mode + ", enabled: " + global_settings.enabled);
    try {
        savedData = context.getParkStorage().get('RCTRando.settings');
        if (savedData)
            info("restored savedData", JSON.stringify(savedData));
    }
    catch (e) {
        printException('error checking savedData: ', e);
    }
    if (savedData && savedData.hasOwnProperty('seed')) {
        loadedGame(savedData);
    }
    else {
        newGame();
    }
    info(rando_name + " v" + rando_version + " finished startup\n               ");
}
var RideType;
(function (RideType) {
    RideType[RideType["Spiral Roller Coaster"] = 0] = "Spiral Roller Coaster";
    RideType[RideType["Stand Up Roller Coaster"] = 1] = "Stand Up Roller Coaster";
    RideType[RideType["Suspended Swinging Coaster"] = 2] = "Suspended Swinging Coaster";
    RideType[RideType["Inverted Roller Coaster"] = 3] = "Inverted Roller Coaster";
    RideType[RideType["Junior Roller Coaster"] = 4] = "Junior Roller Coaster";
    RideType[RideType["Miniature Railway"] = 5] = "Miniature Railway";
    RideType[RideType["Monorail"] = 6] = "Monorail";
    RideType[RideType["Mini Suspended Roller Coaster"] = 7] = "Mini Suspended Roller Coaster";
    RideType[RideType["Boat Hire"] = 8] = "Boat Hire";
    RideType[RideType["Wooden Wild Mouse"] = 9] = "Wooden Wild Mouse";
    RideType[RideType["Steeplechase"] = 10] = "Steeplechase";
    RideType[RideType["Car Ride"] = 11] = "Car Ride";
    RideType[RideType["Launched Freefall"] = 12] = "Launched Freefall";
    RideType[RideType["Bobsleigh Coaster"] = 13] = "Bobsleigh Coaster";
    RideType[RideType["Observation Tower"] = 14] = "Observation Tower";
    RideType[RideType["Looping Roller Coaster"] = 15] = "Looping Roller Coaster";
    RideType[RideType["Dinghy Slide"] = 16] = "Dinghy Slide";
    RideType[RideType["Mine Train Coaster"] = 17] = "Mine Train Coaster";
    RideType[RideType["Chairlift"] = 18] = "Chairlift";
    RideType[RideType["Corkscrew Roller Coaster"] = 19] = "Corkscrew Roller Coaster";
    RideType[RideType["Maze"] = 20] = "Maze";
    RideType[RideType["Spiral Slide"] = 21] = "Spiral Slide";
    RideType[RideType["Go Karts"] = 22] = "Go Karts";
    RideType[RideType["Log Flume"] = 23] = "Log Flume";
    RideType[RideType["River Rapids"] = 24] = "River Rapids";
    RideType[RideType["Dodgems"] = 25] = "Dodgems";
    RideType[RideType["Swinging Ship"] = 26] = "Swinging Ship";
    RideType[RideType["Swinging Inverter Ship"] = 27] = "Swinging Inverter Ship";
    RideType[RideType["Food Stall"] = 28] = "Food Stall";
    RideType[RideType["1d"] = 29] = "1d";
    RideType[RideType["Drink Stall"] = 30] = "Drink Stall";
    RideType[RideType["1f"] = 31] = "1f";
    RideType[RideType["Shop"] = 32] = "Shop";
    RideType[RideType["Merry Go Round"] = 33] = "Merry Go Round";
    RideType[RideType["22 "] = 34] = "22 ";
    RideType[RideType["Information Kiosk"] = 35] = "Information Kiosk";
    RideType[RideType["Toilets"] = 36] = "Toilets";
    RideType[RideType["Ferris Wheel"] = 37] = "Ferris Wheel";
    RideType[RideType["Motion Simulator"] = 38] = "Motion Simulator";
    RideType[RideType["3d Cinema"] = 39] = "3d Cinema";
    RideType[RideType["Top Spin"] = 40] = "Top Spin";
    RideType[RideType["Space Rings"] = 41] = "Space Rings";
    RideType[RideType["Reverse Freefall Coaster"] = 42] = "Reverse Freefall Coaster";
    RideType[RideType["Lift"] = 43] = "Lift";
    RideType[RideType["Vertical Drop Roller Coaster"] = 44] = "Vertical Drop Roller Coaster";
    RideType[RideType["Cash Machine"] = 45] = "Cash Machine";
    RideType[RideType["Twist"] = 46] = "Twist";
    RideType[RideType["Haunted House"] = 47] = "Haunted House";
    RideType[RideType["First Aid"] = 48] = "First Aid";
    RideType[RideType["Circus"] = 49] = "Circus";
    RideType[RideType["Ghost Train"] = 50] = "Ghost Train";
    RideType[RideType["Twister Roller Coaster"] = 51] = "Twister Roller Coaster";
    RideType[RideType["Wooden Roller Coaster"] = 52] = "Wooden Roller Coaster";
    RideType[RideType["Side Friction Roller Coaster"] = 53] = "Side Friction Roller Coaster";
    RideType[RideType["Steel Wild Mouse"] = 54] = "Steel Wild Mouse";
    RideType[RideType["Multidimension Roller Coaster"] = 55] = "Multidimension Roller Coaster";
    RideType[RideType["Multidimension Roller Coaster (alt)"] = 56] = "Multidimension Roller Coaster (alt)";
    RideType[RideType["Flying Roller Coaster"] = 57] = "Flying Roller Coaster";
    RideType[RideType["Flying Roller Coaster (alt)"] = 58] = "Flying Roller Coaster (alt)";
    RideType[RideType["Virginia Reel"] = 59] = "Virginia Reel";
    RideType[RideType["Splash Boats"] = 60] = "Splash Boats";
    RideType[RideType["Mini Helicopters"] = 61] = "Mini Helicopters";
    RideType[RideType["Lay Down Roller Coaster"] = 62] = "Lay Down Roller Coaster";
    RideType[RideType["Suspended Monorail"] = 63] = "Suspended Monorail";
    RideType[RideType["Lay Down Roller Coaster (alt)"] = 64] = "Lay Down Roller Coaster (alt)";
    RideType[RideType["Reverser Roller Coaster"] = 65] = "Reverser Roller Coaster";
    RideType[RideType["Heartline Twister Coaster"] = 66] = "Heartline Twister Coaster";
    RideType[RideType["Mini Golf"] = 67] = "Mini Golf";
    RideType[RideType["Giga Coaster"] = 68] = "Giga Coaster";
    RideType[RideType["Roto Drop"] = 69] = "Roto Drop";
    RideType[RideType["Flying Saucers"] = 70] = "Flying Saucers";
    RideType[RideType["Crooked House"] = 71] = "Crooked House";
    RideType[RideType["Monorail Cycles"] = 72] = "Monorail Cycles";
    RideType[RideType["Compact Inverted Coaster"] = 73] = "Compact Inverted Coaster";
    RideType[RideType["Water Coaster"] = 74] = "Water Coaster";
    RideType[RideType["Air Powered Vertical Coaster"] = 75] = "Air Powered Vertical Coaster";
    RideType[RideType["Inverted Hairpin Coaster"] = 76] = "Inverted Hairpin Coaster";
    RideType[RideType["Magic Carpet"] = 77] = "Magic Carpet";
    RideType[RideType["Submarine Ride"] = 78] = "Submarine Ride";
    RideType[RideType["River Rafts"] = 79] = "River Rafts";
    RideType[RideType["Type 50"] = 80] = "Type 50";
    RideType[RideType["Enterprise"] = 81] = "Enterprise";
    RideType[RideType["52 "] = 82] = "52 ";
    RideType[RideType["53 "] = 83] = "53 ";
    RideType[RideType["54 "] = 84] = "54 ";
    RideType[RideType["55 "] = 85] = "55 ";
    RideType[RideType["Inverted Impulse Coaster"] = 86] = "Inverted Impulse Coaster";
    RideType[RideType["Mini Roller Coaster"] = 87] = "Mini Roller Coaster";
    RideType[RideType["Mine Ride"] = 88] = "Mine Ride";
    RideType[RideType["59 "] = 89] = "59 ";
    RideType[RideType["LIM Launched Roller Coaster"] = 90] = "LIM Launched Roller Coaster";
    RideType[RideType["Hypercoaster"] = 91] = "Hypercoaster";
    RideType[RideType["Hypertwister"] = 92] = "Hypertwister";
    RideType[RideType["Monster Trucks"] = 93] = "Monster Trucks";
    RideType[RideType["Spinning Wild Mouse"] = 94] = "Spinning Wild Mouse";
    RideType[RideType["Classic Mini Roller Coaster"] = 95] = "Classic Mini Roller Coaster";
    RideType[RideType["Hybrid Coaster"] = 96] = "Hybrid Coaster";
    RideType[RideType["Single Rail Roller Coaster"] = 97] = "Single Rail Roller Coaster";
    RideType[RideType["Alpine Roller Coaster"] = 98] = "Alpine Roller Coaster";
    RideType[RideType["Classic Wooden Roller Coaster"] = 99] = "Classic Wooden Roller Coaster";
})(RideType || (RideType = {}));
function test_difficulty(goal, d) {
    settings.difficulty = goal;
    var currDifficulty = 1;
    var num = 1000;
    info('                  \ntest_difficulty', goal, d, JSON.stringify(settings.rando_range));
    var total = 0;
    for (var i = 0; i < num; i++) {
        total += GetDifficultyCurve(d);
    }
    info("difficulty " + goal + ", " + d + ", avg: " + (total / num));
    total = 0;
    for (var i = 0; i < num; i++) {
        total += Number(RngBoolWithDifficulty(d));
    }
    info("    RngBoolWithDifficulty difficulty " + goal + ", " + d + ", avg: " + (total / num));
    var min = 1;
    var max = 1;
    var highs = 0;
    var lows = 0;
    total = 0;
    for (var i = 0; i < num; i++) {
        var v = randomize(1, d);
        min = Math.min(min, v);
        max = Math.max(max, v);
        if (v > 1)
            highs++;
        if (v < 1)
            lows++;
        total += v;
    }
    info("    randomize difficulty " + goal + ", " + d + ", avg: " + (total / num) + ', min: ' + min + ', max: ' + max + ', lows: ' + lows + ', highs: ' + highs);
}
function run_tests() {
    info('starting tests...');
    info(RideType[1]);
    setGlobalSeed(25);
    var oldRange = settings.rando_range;
    settings.rando_range = randoRanges['Medium'];
    for (var d = -0.6; d < 0.7; d += 0.6) {
        for (var i = -1; i <= 1; i += 1) {
            test_difficulty(d, i);
        }
    }
    for (var r in randoRanges) {
        settings.rando_range = randoRanges[r];
        info('            \nrun_tests range', r);
        test_difficulty(0, 0);
    }
    settings.rando_range = randoRanges['Extreme'];
    test_difficulty(difficulties['Extreme'], 1);
    test_difficulty(difficulties['Extreme'], -1);
    settings.rando_range = oldRange;
    settings.difficulty = 1;
    info('finished tests');
}
var adPool = [
    {
        title: "Look Here!",
        header: "Centipedes? In My Park?",
        message: "It's more likely than you think.",
        button: "Find Out More"
    },
    {
        title: "FREE!!!!!!!!!!!!!!!!",
        header: "Get Free Money!!",
        message: "Get Money Right Now!!",
        button: "Get $1000"
    },
    {
        title: "Great Product",
        header: "Hate Ads?",
        message: "Download Our Popup Blocker",
        button: "Download Now"
    },
    {
        title: "",
        header: "WARNING!",
        message: "Your PC is about to explode",
        button: "Fix Now"
    },
    {
        title: "Alert",
        header: "Your park is being attacked",
        message: " by bandits. We can help!",
        button: "HELP!"
    },
    {
        title: "Famous!",
        header: "Become Famous!",
        message: "Get 1,000 guests right now!",
        button: "Win"
    },
    {
        title: "Congrats!",
        header: "Congratulations",
        message: "You are the 100,000th player of OpenRCT2!",
        button: "Redeem Prize"
    },
    {
        title: "Free Rides",
        header: "Download Roller Coaster for your park!",
        message: "Excitement guaranteed!",
        button: "Download"
    },
    {
        title: "Invest",
        header: "Invest in RCT Stock",
        message: "Make $1000s!",
        button: "Take Me There"
    },
    {
        title: "Broke?",
        header: "Need a Lawyer?",
        message: "Sawyer Law Offices can help",
        button: "Call"
    },
    {
        title: "Did You Know?",
        header: "1% of Tycoons Don't Know",
        message: "These ten simple tricks!",
        button: "Click Here"
    },
    {
        title: "Survey",
        header: "Complete our survey",
        message: "You can win big bucks!",
        button: "Take Survey"
    },
    {
        title: "Advice",
        header: "Need Coaster Advice?",
        message: "",
        button: "Call Now"
    },
    {
        title: "CC",
        header: "Looking for excitement?",
        message: "Look to Crowd Control!",
        button: "https://crowdcontrol.live/"
    },
    {
        title: "RCT2",
        header: "Enjoying Yourself?",
        message: "Play OpenRCT2 Yourself!",
        button: "https://openrct2.org/"
    },
    {
        title: "Action Required",
        header: "You're Being Sued!",
        message: "",
        button: "View Details"
    },
    {
        title: "Popup",
        header: "",
        message: "Your Text Here",
        button: "Button"
    },
    {
        title: "Woah!!",
        header: "Looking for Rides?",
        message: "We have the best rides in %{location}",
        button: "See More"
    },
    {
        title: "Popups",
        header: "Make Your Own Popup!",
        message: "",
        button: "We Can Help"
    },
    {
        title: "Download",
        header: "Here is your download:",
        message: "openrct3.dat (43.5 mB)",
        button: "DOWNLOAD"
    }
];
function showAd(ad) {
    if (ui) {
        ui.openWindow({
            classification: "popup",
            title: ad.title,
            width: 300,
            height: 100,
            colours: [context.getRandom(0, 32), context.getRandom(0, 32)],
            widgets: [
                {
                    type: "label",
                    x: 0,
                    y: 25,
                    width: 300,
                    height: 25,
                    text: ad.header,
                    textAlign: "centred"
                },
                {
                    type: "label",
                    x: 0,
                    y: 50,
                    width: 300,
                    height: 25,
                    text: ad.message,
                    textAlign: "centred"
                },
                {
                    type: "button",
                    x: 0,
                    y: 75,
                    width: 300,
                    height: 25,
                    text: ad.button
                }
            ]
        });
    }
}
function showRandomAd() {
    var adId = context.getRandom(0, adPool.length);
    showAd(adPool[adId]);
}
var CCStatus;
(function (CCStatus) {
    CCStatus[CCStatus["SUCCESS"] = 0] = "SUCCESS";
    CCStatus[CCStatus["FAILED"] = 1] = "FAILED";
    CCStatus[CCStatus["NOT_AVAILABLE"] = 2] = "NOT_AVAILABLE";
    CCStatus[CCStatus["RETRY"] = 3] = "RETRY";
})(CCStatus || (CCStatus = {}));
var CCRequestType;
(function (CCRequestType) {
    CCRequestType[CCRequestType["START"] = 1] = "START";
    CCRequestType[CCRequestType["STOP"] = 2] = "STOP";
})(CCRequestType || (CCRequestType = {}));
var Cheat;
(function (Cheat) {
    Cheat[Cheat["SandboxMode"] = 0] = "SandboxMode";
    Cheat[Cheat["DisableClearanceChecks"] = 1] = "DisableClearanceChecks";
    Cheat[Cheat["DisableSupportLimits"] = 2] = "DisableSupportLimits";
    Cheat[Cheat["ShowAllOperatingModes"] = 3] = "ShowAllOperatingModes";
    Cheat[Cheat["ShowVehiclesFromOtherTrackTypes"] = 4] = "ShowVehiclesFromOtherTrackTypes";
    Cheat[Cheat["DisableTrainLengthLimit"] = 5] = "DisableTrainLengthLimit";
    Cheat[Cheat["EnableChainLiftOnAllTrack"] = 6] = "EnableChainLiftOnAllTrack";
    Cheat[Cheat["FastLiftHill"] = 7] = "FastLiftHill";
    Cheat[Cheat["DisableBrakesFailure"] = 8] = "DisableBrakesFailure";
    Cheat[Cheat["DisableAllBreakdowns"] = 9] = "DisableAllBreakdowns";
    Cheat[Cheat["UnlockAllPrices"] = 10] = "UnlockAllPrices";
    Cheat[Cheat["BuildInPauseMode"] = 11] = "BuildInPauseMode";
    Cheat[Cheat["IgnoreRideIntensity"] = 12] = "IgnoreRideIntensity";
    Cheat[Cheat["DisableVandalism"] = 13] = "DisableVandalism";
    Cheat[Cheat["DisableLittering"] = 14] = "DisableLittering";
    Cheat[Cheat["NoMoney"] = 15] = "NoMoney";
    Cheat[Cheat["AddMoney"] = 16] = "AddMoney";
    Cheat[Cheat["SetMoney"] = 17] = "SetMoney";
    Cheat[Cheat["ClearLoan"] = 18] = "ClearLoan";
    Cheat[Cheat["SetGuestParameter"] = 19] = "SetGuestParameter";
    Cheat[Cheat["GenerateGuests"] = 20] = "GenerateGuests";
    Cheat[Cheat["RemoveAllGuests"] = 21] = "RemoveAllGuests";
    Cheat[Cheat["GiveAllGuests"] = 22] = "GiveAllGuests";
    Cheat[Cheat["SetGrassLength"] = 23] = "SetGrassLength";
    Cheat[Cheat["waterplants"] = 24] = "waterplants";
    Cheat[Cheat["DisablePlantAging"] = 25] = "DisablePlantAging";
    Cheat[Cheat["FixVandalism"] = 26] = "FixVandalism";
    Cheat[Cheat["RemoveLitter"] = 27] = "RemoveLitter";
    Cheat[Cheat["SetStaffSpeed"] = 28] = "SetStaffSpeed";
    Cheat[Cheat["RenewRides"] = 29] = "RenewRides";
    Cheat[Cheat["MakeDestructible"] = 30] = "MakeDestructible";
    Cheat[Cheat["fixrides"] = 31] = "fixrides";
    Cheat[Cheat["ResetCrashStatus"] = 32] = "ResetCrashStatus";
    Cheat[Cheat["TenMinuteInspections"] = 33] = "TenMinuteInspections";
    Cheat[Cheat["WinScenario"] = 34] = "WinScenario";
    Cheat[Cheat["ForceWeather"] = 35] = "ForceWeather";
    Cheat[Cheat["freezeweather"] = 36] = "freezeweather";
    Cheat[Cheat["OpenClosePark"] = 37] = "OpenClosePark";
    Cheat[Cheat["HaveFun"] = 38] = "HaveFun";
    Cheat[Cheat["SetForcedParkRating"] = 39] = "SetForcedParkRating";
    Cheat[Cheat["NeverEndingMarketing"] = 40] = "NeverEndingMarketing";
    Cheat[Cheat["AllowArbitraryRideTypeChanges"] = 41] = "AllowArbitraryRideTypeChanges";
    Cheat[Cheat["OwnAllLand"] = 42] = "OwnAllLand";
    Cheat[Cheat["DisableRideValueAging"] = 43] = "DisableRideValueAging";
    Cheat[Cheat["IgnoreResearchStatus"] = 44] = "IgnoreResearchStatus";
    Cheat[Cheat["EnableAllDrawableTrackPieces"] = 45] = "EnableAllDrawableTrackPieces";
    Cheat[Cheat["CreateDucks"] = 46] = "CreateDucks";
    Cheat[Cheat["RemoveDucks"] = 47] = "RemoveDucks";
    Cheat[Cheat["AllowTrackPlaceInvalidHeights"] = 48] = "AllowTrackPlaceInvalidHeights";
    Cheat[Cheat["Count"] = 49] = "Count";
})(Cheat || (Cheat = {}));
function noop(result) { }
function rctMessage(text, type) {
    if (type === void 0) { type = "money"; }
    park.postMessage({
        type: type,
        text: text
    });
}
function cheat(cheat, p1, p2) {
    if (p1 === void 0) { p1 = 0; }
    if (p2 === void 0) { p2 = 0; }
    context.executeAction("setcheat", {
        type: cheat,
        param1: p1,
        param2: p2
    }, function (result) {
        console.log('setcheat(', cheat, p1, p2, ') result:', result);
    });
}
var Handler = (function () {
    function Handler(startEffect, stopEffect) {
        if (stopEffect === void 0) { stopEffect = function (effect) { return CCStatus.SUCCESS; }; }
        this.startEffect = startEffect;
        this.stopEffect = stopEffect;
    }
    return Handler;
}());
function addMoney(effect, amount) {
    cheat(Cheat.AddMoney, amount * 10);
    if (amount < 0) {
        rctMessage("".concat(effect.viewer, " stole $").concat(-amount, ".00 from you!"));
    }
    else if (amount > 0) {
        rctMessage("".concat(effect.viewer, " donated $").concat(amount, ".00 to you!"));
    }
    return CCStatus.SUCCESS;
}
function clearLoan(effect) {
    cheat(Cheat.ClearLoan);
    rctMessage("".concat(effect.viewer, " paid off your loan!"));
    return CCStatus.SUCCESS;
}
function spawnducks(effect) {
    cheat(Cheat.CreateDucks, 100);
    rctMessage("".concat(effect.viewer, " released the ducks!"));
    return CCStatus.SUCCESS;
}
function despawnducks(effect) {
    cheat(Cheat.RemoveDucks);
    rctMessage("".concat(effect.viewer, " killed all the ducks!"));
    return CCStatus.SUCCESS;
}
function goBackOneMonth(effect) {
    var monthsElapsed = date.monthsElapsed - 1;
    if (monthsElapsed < 0) {
        return CCStatus.FAILED;
    }
    var year = Math.floor(monthsElapsed / 8) + 1;
    var month = monthsElapsed % 8 + 1;
    context.executeAction("parksetdate", {
        year: year,
        month: month,
        day: date.day
    }, noop);
    rctMessage("".concat(effect.viewer, " forced the date to ").concat(formatDate(date.day, month, year)));
    return CCStatus.SUCCESS;
}
function goBackToStart(effect) {
    context.executeAction("parksetdate", {
        year: 1,
        month: 1,
        day: 1
    }, noop);
    rctMessage("".concat(effect.viewer, " forced the date to March, Year 1"));
    return CCStatus.SUCCESS;
}
function forcewin(effect) {
    cheat(Cheat.WinScenario);
    rctMessage("".concat(effect.viewer, " forced you to win!"));
    return CCStatus.SUCCESS;
}
function forceWeather(effect, weather) {
    if (!weather) {
        weather = context.getRandom(0, 9);
    }
    cheat(Cheat.ForceWeather, weather);
    rctMessage("".concat(effect.viewer, " changed the weather!"));
    return CCStatus.SUCCESS;
}
function freezeweather(effect) {
    cheat(Cheat.freezeweather, 1);
    rctMessage("".concat(effect.viewer, " halted weather changes!"));
    return CCStatus.SUCCESS;
}
function unfreezeweather(effect) {
    cheat(Cheat.freezeweather, 0);
    rctMessage("The weather is back to normal now...");
    return CCStatus.SUCCESS;
}
function fixallrides(effect) {
    cheat(Cheat.fixrides);
    rctMessage("".concat(effect.viewer, " fixed all the rides!"));
    return CCStatus.SUCCESS;
}
function fastchainlifts(effect) {
    cheat(Cheat.FastLiftHill, 1);
    for (var i = 0; i < map.numRides; i++) {
        var ride = map.getRide(i);
        if (ride.classification == "ride") {
            context.executeAction("ridesetsetting", {
                ride: ride.id,
                setting: 8,
                value: 100
            }, noop);
        }
    }
    rctMessage("".concat(effect.viewer, " sped up the chain lifts!"));
    return CCStatus.SUCCESS;
}
function slowchainlifts(effect) {
    cheat(Cheat.FastLiftHill, 1);
    for (var i = 0; i < map.numRides; i++) {
        var ride = map.getRide(i);
        if (ride.classification == "ride") {
            context.executeAction("ridesetsetting", {
                ride: ride.id,
                setting: 8,
                value: 1
            }, noop);
        }
    }
    rctMessage("".concat(effect.viewer, " slowed down the chain lifts!"));
    return CCStatus.SUCCESS;
}
var peepQueue = [];
function peepnameafterdonator(effect) {
    peepQueue.push(effect.viewer);
    return CCStatus.SUCCESS;
}
function peepRandomColor(effect) {
    var color = context.getRandom(0, 31);
    context.executeAction("guestSetColor", { color: color }, noop);
    rctMessage("".concat(effect.viewer, " changed the fashion!"));
    return CCStatus.SUCCESS;
}
function peepHungry(effect) {
    cheat(Cheat.SetGuestParameter, 2, 0);
    rctMessage("".concat(effect.viewer, " made the guests ravenous."));
    return CCStatus.SUCCESS;
}
function peepFull(effect) {
    cheat(Cheat.SetGuestParameter, 2, 255);
    rctMessage("".concat(effect.viewer, " made the guests stuffed."));
    return CCStatus.SUCCESS;
}
function peepThirsty(effect) {
    cheat(Cheat.SetGuestParameter, 3, 0);
    rctMessage("".concat(effect.viewer, " made the guests very thirsty."));
    return CCStatus.SUCCESS;
}
function peepQuench(effect) {
    cheat(Cheat.SetGuestParameter, 3, 255);
    rctMessage("".concat(effect.viewer, " made the guests no longer thirsty."));
    return CCStatus.SUCCESS;
}
function peepPee(effect) {
    cheat(Cheat.SetGuestParameter, 6, 255);
    rctMessage("".concat(effect.viewer, " made the guests need to use the restroom."));
    return CCStatus.SUCCESS;
}
function peepNoPee(effect) {
    cheat(Cheat.SetGuestParameter, 6, 0);
    rctMessage("".concat(effect.viewer, " made the guests no longer need to use the restroom."));
    return CCStatus.SUCCESS;
}
function peepGiveCash(effect, amount) {
    context.executeAction("guestAddMoney", { money: amount }, noop);
    if (amount < 0) {
        rctMessage("".concat(effect.viewer, " stole $").concat(amount, ".00 from all the guests."));
    }
    else if (amount > 0) {
        rctMessage("".concat(effect.viewer, " gave $").concat(amount, ".00 to all the guests."));
    }
    return CCStatus.SUCCESS;
}
function peepgiveballoon(effect) {
    cheat(Cheat.GiveAllGuests, 2);
    rctMessage("".concat(effect.viewer, " gave everyone a balloon!"));
    return CCStatus.SUCCESS;
}
function removeLitter(effect) {
    cheat(Cheat.RemoveLitter);
    rctMessage("".concat(effect.viewer, " cleaned the place up!"));
    return CCStatus.SUCCESS;
}
function mowgrass(effect) {
    cheat(Cheat.SetGrassLength, 0);
    rctMessage("".concat(effect.viewer, " mowed the lawn!"));
    return CCStatus.SUCCESS;
}
function unmowgrass(effect) {
    cheat(Cheat.SetGrassLength, 100);
    rctMessage("".concat(effect.viewer, " made the grass grow!"));
    return CCStatus.SUCCESS;
}
function waterplants(effect) {
    cheat(Cheat.waterplants);
    rctMessage("".concat(effect.viewer, " watered the plants!"));
    return CCStatus.SUCCESS;
}
function killPlants(effect) {
    context.executeAction("killPlants", {}, noop);
    rctMessage("".concat(effect.viewer, " killed the plants!"));
    return CCStatus.SUCCESS;
}
function breakThings(effect) {
    context.executeAction("breakThings", {}, noop);
    rctMessage("".concat(effect.viewer, " broke things!"));
    return CCStatus.SUCCESS;
}
function fixThings(effect) {
    cheat(Cheat.FixVandalism);
    rctMessage("".concat(effect.viewer, " fixed things!"));
    return CCStatus.SUCCESS;
}
function spawnRandomWindows(effect) {
    if (ui) {
        var randomNumber = context.getRandom(1, 6);
        for (var i = 0; i < randomNumber; i++) {
            showRandomAd();
        }
        return CCStatus.SUCCESS;
    }
    return CCStatus.FAILED;
}
function closeallwindows(effect) {
    if (ui) {
        ui.closeAllWindows();
        rctMessage("".concat(effect.viewer, " closed your windows!"));
    }
    return CCStatus.FAILED;
}
function rerollRides(effect) {
    settings.cycle_offset++;
    SaveSettings();
    rctMessage("".concat(effect.viewer, " re-randomized your rides!"));
    return CCStatus.SUCCESS;
}
function extendScenario(effect) {
    scenario.objective.year++;
    rctMessage("".concat(effect.viewer, " extended your scenario!"));
    return CCStatus.SUCCESS;
}
var handlers = {
    give100: new Handler(function (effect) { return addMoney(effect, 100); }),
    give1000: new Handler(function (effect) { return addMoney(effect, 1000); }),
    take100: new Handler(function (effect) { return addMoney(effect, -100); }),
    take1000: new Handler(function (effect) { return addMoney(effect, -1000); }),
    zeroloan: new Handler(clearLoan),
    minusonemonth: new Handler(goBackOneMonth),
    resetdate: new Handler(goBackToStart),
    forcewin: new Handler(forcewin),
    forceweatherrandom: new Handler(function (effect) { return forceWeather(effect); }),
    forceweather0: new Handler(function (effect) { return forceWeather(effect, 0); }),
    forceweather1: new Handler(function (effect) { return forceWeather(effect, 1); }),
    forceweather2: new Handler(function (effect) { return forceWeather(effect, 2); }),
    forceweather3: new Handler(function (effect) { return forceWeather(effect, 3); }),
    forceweather4: new Handler(function (effect) { return forceWeather(effect, 4); }),
    forceweather5: new Handler(function (effect) { return forceWeather(effect, 5); }),
    forceweather6: new Handler(function (effect) { return forceWeather(effect, 6); }),
    forceweather7: new Handler(function (effect) { return forceWeather(effect, 7); }),
    forceweather8: new Handler(function (effect) { return forceWeather(effect, 8); }),
    freezeweather: new Handler(freezeweather, unfreezeweather),
    fixallrides: new Handler(fixallrides),
    fastchainlift: new Handler(fastchainlifts),
    slowchainlift: new Handler(slowchainlifts),
    peepnameafterdonator: new Handler(peepnameafterdonator),
    peeprecolor: new Handler(peepRandomColor),
    peepfeed: new Handler(peepFull),
    peepunfeed: new Handler(peepHungry),
    peepdrink: new Handler(peepQuench),
    peepundrink: new Handler(peepThirsty),
    peepfillbladder: new Handler(peepPee),
    peepemptybladder: new Handler(peepNoPee),
    peepgivemoney: new Handler(function (effect) { return peepGiveCash(effect, 20); }),
    peeptakemoney: new Handler(function (effect) { return peepGiveCash(effect, -20); }),
    peepgiveballoon: new Handler(peepgiveballoon),
    cleanpaths: new Handler(removeLitter),
    mowgrass: new Handler(mowgrass),
    unmowgrass: new Handler(unmowgrass),
    waterplants: new Handler(waterplants),
    burnplants: new Handler(killPlants),
    smashscenery: new Handler(breakThings),
    fixscenery: new Handler(fixThings),
    spawnducks: new Handler(spawnducks),
    clearducks: new Handler(despawnducks),
    openrandomwindows: new Handler(spawnRandomWindows),
    closeallwindows: new Handler(closeallwindows),
    rerollrides: new Handler(rerollRides),
    extendscenario: new Handler(extendScenario)
};
function handle(effect) {
    var handler = handlers[effect.code];
    if (handler && effect.type == CCRequestType.START) {
        return handler.startEffect(effect);
    }
    else if (handler && effect.type == CCRequestType.STOP) {
        return handler.stopEffect(effect);
    }
    else {
        return CCStatus.FAILED;
    }
}
function getChangeText(change) {
    var str;
    var name = change.name;
    if (change.factor) {
        var factor = change.factor;
        factor = Math.round(factor * 100 + Number.EPSILON) / 100;
        str = name + ' ' + factor + 'x';
    }
    else {
        var isMoney = name in { 'bankLoan': 1, 'maxBankLoan': 1, 'cash': 1, 'constructionRightsPrice': 1, 'landPrice': 1, 'parkValue': 1 };
        var isBool = (typeof (change.from) === 'boolean' && typeof (change.to) === 'boolean');
        var from = change.from;
        var to = change.to;
        if (isMoney) {
            from /= 10;
            to /= 10;
        }
        from = numberWithCommas(from, isMoney);
        to = numberWithCommas(to, isMoney);
        if (isBool && to)
            str = name + ' enabled';
        else if (isBool)
            str = name + ' disabled';
        else
            str = name + ' changed from ' + from + ' to ' + to;
    }
    return str;
}
function getChangesList(widget) {
    var ret = [];
    var rides = [];
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        for (var k in m.settings.changes) {
            var change = m.settings.changes[k];
            var str = getChangeText(change);
            if (k.startsWith('ride:'))
                rides.push(str);
            else
                ret.push(str);
        }
    }
    ret.sort();
    rides.sort();
    ret.unshift('Seed: ' + globalseed);
    if (rides.length > 0) {
        ret.push('==== Ride Types: ====');
        ret = ret.concat(rides);
    }
    if (!widget)
        return ret;
    if (widget.items.length != ret.length) {
        widget.items = ret;
        return ret;
    }
    var changed = false;
    for (var i in ret) {
        if (widget.items[i][0] !== ret[i]) {
            changed = true;
            break;
        }
    }
    if (changed)
        widget.items = ret;
    return ret;
}
function createChangesWindow(window_height, window_width) {
    if (window_height === void 0) { window_height = 350; }
    if (window_width === void 0) { window_width = 400; }
    var window;
    var changes_list;
    var resize_button;
    var paddingLeft = 7;
    var paddingRight = 7;
    var paddingTop = 16;
    var paddingBottom = 7;
    var ticker = context.setInterval(function () {
        getChangesList(changes_list);
    }, 1000);
    var changes_list_desc = {
        type: 'listview',
        name: 'changes-list',
        x: paddingLeft,
        y: paddingTop,
        width: window_width - 1 - paddingLeft - paddingRight,
        height: window_height - paddingTop - paddingBottom,
        scrollbars: "vertical",
        items: getChangesList(null)
    };
    window = ui.openWindow({
        classification: 'rando-changes',
        title: "RollerCoaster Tycoon Randomizer v" + rando_version,
        width: window_width,
        height: window_height,
        minWidth: 80,
        minHeight: 30,
        maxWidth: 600,
        maxHeight: 5000,
        widgets: [
            changes_list_desc,
            {
                type: 'button',
                name: 'fix-size-button',
                x: paddingLeft,
                y: 15,
                width: 50,
                height: 14,
                text: 'Resize',
                isVisible: false,
                onClick: function () {
                    window.width = window_width;
                    window.height = window_height;
                    resize_button.isVisible = false;
                }
            }
        ],
        onClose: function () {
            context.clearInterval(ticker);
        },
        onUpdate: function () {
            changes_list.width = window.width - 1 - paddingLeft - paddingRight;
            changes_list.height = window.height - paddingTop - paddingBottom;
            if (changes_list.height < 100 && changes_list.scrollbars == 'vertical') {
                changes_list.isVisible = false;
                changes_list.scrollbars = 'none';
                resize_button.isVisible = true;
            }
            else if (changes_list.height > 100 && changes_list.scrollbars == 'none') {
                resize_button.isVisible = false;
                changes_list.isVisible = true;
                changes_list.scrollbars = 'vertical';
            }
        }
    });
    changes_list = window.findWidget('changes-list');
    resize_button = window.findWidget('fix-size-button');
}
function NewWidget(widget) {
    var margin = 3;
    var window_width = 350 - margin * 2;
    var start_y = 26;
    var cellWidth = (window_width - margin * 3) / 2;
    var cellHeight = 26;
    widget.x *= cellWidth + margin;
    widget.x += margin;
    if (!widget.width)
        widget.width = 1;
    widget.width *= cellWidth;
    widget.y *= cellHeight + margin * 2;
    widget.y += start_y;
    widget.height = cellHeight;
    return widget;
}
function NewLabel(label, desc) {
    desc = Object.assign({}, desc);
    desc.type = 'label';
    desc.name = 'label-' + desc.name;
    desc.x = 0;
    desc.text = label;
    desc.textAlign = 'centred';
    return NewWidget(desc);
}
function NewEdit(label, desc) {
    label = NewLabel(label, desc);
    desc.x = 1;
    desc.y -= 0.2;
    desc.type = 'textbox';
    var edit = NewWidget(desc);
    return [label, edit];
}
function NewDropdown(label, desc) {
    label = NewLabel(label, desc);
    desc.x = 1;
    desc.y -= 0.2;
    desc.type = 'dropdown';
    var dropdown = NewWidget(desc);
    return [label, dropdown];
}
function GetSelectedIndex(items, value) {
    var keys = Object.keys(items);
    var closest = 0;
    var closest_dist = 99999999;
    for (var i = 0; i < keys.length; i++) {
        var v = items[keys[i]];
        if (v == value)
            return i;
        var dist = Math.abs(v - value);
        if (dist < closest_dist) {
            closest = i;
            closest_dist = dist;
        }
    }
    return closest;
}
function NewCheckbox(name, text, x, y, tooltip, checked) {
    return NewWidget({
        type: 'checkbox',
        name: name,
        text: text,
        x: x + 0.1,
        y: y,
        width: 1,
        tooltip: tooltip,
        isChecked: (checked === undefined) ? true : checked
    });
}
function initMenuItems() {
    if (initedMenuItems)
        return;
    if (typeof ui !== 'undefined') {
        ui.registerMenuItem("RCTRando Changes", createChangesWindow);
        ui.registerMenuItem("RCTRando Options", createOptionsWindow);
        initedMenuItems = true;
    }
}
function numberWithCommas(x, isMoney) {
    if (isMoney === void 0) { isMoney = false; }
    var parts = x.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    if (isMoney && parts.length > 1 && parts[1].length == 1)
        parts[1] += '0';
    return parts.join(".");
}
function createOptionsWindow() {
    var window;
    var window_height = 200;
    var window_width = 250;
    var randoEnabledDesc = NewCheckbox('rando-enabled', 'Enable Randomizer', 0, 1, 'Enable or Disable the Randomizer plugin.', global_settings.enabled);
    randoEnabledDesc.onChange = EnableDisableRando;
    var autoPauseDesc = NewCheckbox('auto-pause', 'Auto Pause', 0, 2, 'Automatically pause the game at the start so you can read the changes list.', global_settings.auto_pause);
    autoPauseDesc.onChange = function (checked) {
        global_settings.auto_pause = checked;
        SaveGlobalSettings();
    };
    var reuseSeedDesc = NewCheckbox('reuse-seed', 'Reuse Seed', 0, 3, 'Reuse the previously used seed by default.', global_settings.reuse_seed);
    reuseSeedDesc.onChange = function (checked) {
        global_settings.reuse_seed = checked;
        SaveGlobalSettings();
    };
    var reuseSettingsDesc = NewCheckbox('reuse-settings', 'Reuse Settings', 0, 4, 'Reuse the previously used settings by default.', global_settings.reuse_settings);
    reuseSettingsDesc.onChange = function (checked) {
        global_settings.reuse_settings = checked;
        SaveGlobalSettings();
    };
    window = ui.openWindow({
        classification: 'rando-options',
        title: "RollerCoaster Tycoon Randomizer v" + rando_version,
        width: window_width,
        height: window_height,
        widgets: [
            NewLabel('https://discord.gg/jjfKT9nYDR', {
                name: 'url',
                y: 0,
                width: 1.3,
                tooltip: 'Join the Discord!'
            }),
            randoEnabledDesc, autoPauseDesc, reuseSeedDesc, reuseSettingsDesc
        ]
    });
}
function startGameGui() {
    info('startGameGui()', globalseed);
    var ww = 350;
    var wh = 350;
    if (typeof ui === 'undefined') {
        info('startGameGui() ui is undefined');
        initRando();
        return;
    }
    if (global_settings.auto_pause) {
        PauseGame();
    }
    var y = 0;
    var onStart = function (window) {
        var s = window.findWidget('edit-seed');
        setGlobalSeed(s['text']);
        var d = window.findWidget('difficulty');
        settings.difficulty = difficulties[d['text']];
        var r = window.findWidget('range');
        settings.rando_range = randoRanges[r['text']];
        var l = window.findWidget('length');
        settings.scenarioLength = scenarioLengths[l['text']];
        settings.rando_ride_types = window.findWidget('rando-ride-types').isChecked;
        settings.rando_park_flags = window.findWidget('rando-park-flags').isChecked;
        settings.rando_park_values = window.findWidget('rando-park-values').isChecked;
        settings.rando_goals = window.findWidget('rando-goals').isChecked;
        settings.rando_crowdcontrol = window.findWidget('rando-crowdcontrol').isChecked;
        var cycle = window.findWidget('reroll-frequency');
        settings.num_months_cycle = randoCycles[cycle['text']];
        var wasPaused = UnpauseGame();
        runNextTick(function () {
            initRando();
            if (wasPaused.wasPaused && global_settings.auto_pause) {
                context.executeAction('pausetoggle', {});
            }
            createChangesWindow();
        });
    };
    var window = ui.openWindow({
        classification: 'rando-settings',
        title: "RollerCoaster Tycoon Randomizer v" + rando_version,
        width: ww,
        height: wh,
        widgets: [].concat(NewLabel('https://discord.gg/jjfKT9nYDR', {
            name: 'url',
            y: y++,
            width: 2,
            tooltip: 'Join the Discord!'
        }), NewEdit('Seed:', {
            name: 'edit-seed',
            y: y++,
            text: '' + globalseed,
            tooltip: 'Enter a number'
        }), NewDropdown('Difficulty:', {
            name: 'difficulty',
            y: y++,
            items: Object.keys(difficulties),
            selectedIndex: GetSelectedIndex(difficulties, settings.difficulty),
            tooltip: 'Choose a difficulty for the randomization'
        }), NewDropdown('Randomization Range:', {
            name: 'range',
            y: y++,
            items: Object.keys(randoRanges),
            selectedIndex: GetSelectedIndex(randoRanges, settings.rando_range),
            tooltip: 'The range/spread of randomized values.'
        }), NewDropdown('Scenario Length:', {
            name: 'length',
            y: y++,
            items: Object.keys(scenarioLengths),
            selectedIndex: GetSelectedIndex(scenarioLengths, settings.scenarioLength),
            tooltip: 'Longer scenario length will also scale up the goals so that difficulty is maintained.'
        }), NewDropdown('Ride Type Stat Re-rolls:', {
            name: 'reroll-frequency',
            y: y++,
            items: Object.keys(randoCycles),
            selectedIndex: GetSelectedIndex(randoCycles, settings.num_months_cycle),
            tooltip: 'How often to rerandomize the stats for ride types. Build the Theme Park of Theseus.'
        }), NewCheckbox('rando-ride-types', 'Randomize Ride Types', 0, y, 'Randomizes values such as excitement, intensity, and runningCost', settings.rando_ride_types), NewCheckbox('rando-park-flags', 'Randomize Park Rules', 1, y++, 'Randomizes flags such as forbidMarketingCampaigns and preferMoreIntenseRides', settings.rando_park_flags), NewCheckbox('rando-park-values', 'Randomize Park Values', 0, y, 'Randomizes values such as starting cash, starting bank loan amount, maxBankLoan, and landPrice', settings.rando_park_values), NewCheckbox('rando-goals', 'Randomize Goals', 1, y++, 'Even when disabled, goals will still be scaled by Scenario Length', settings.rando_goals), NewCheckbox('rando-crowdcontrol', 'Enable Crowd Control', 0, y++, 'Let your viewers mess with your game! Visit https://crowdcontrol.live/ for info', settings.rando_crowdcontrol), [{
                type: 'button',
                name: 'cancel-button',
                x: ww - 90 - 6,
                y: wh - 6 - 26 - 29,
                width: 90,
                height: 26,
                text: 'Disable Rando',
                onClick: function () {
                    EnableDisableRando(false);
                    window.close();
                }
            },
            {
                type: 'button',
                name: 'ok-button',
                x: ww - 90 - 6,
                y: wh - 6 - 26,
                width: 90,
                height: 26,
                text: 'Start Game',
                onClick: function () {
                    window.close();
                }
            }]),
        onClose: function () {
            try {
                if (global_settings.enabled)
                    onStart(window);
            }
            catch (e) {
                printException('error in GUI onClick(): ', e);
            }
        }
    });
    initMenuItems();
    return window;
}
var ModuleBase = (function () {
    function ModuleBase() {
        this.subscriptions = [];
        this.settings = { enabled: true, changes: {} };
    }
    ModuleBase.prototype.LoadSettings = function () {
        if (!settings[this.constructor.name]) {
            this.SaveSettings();
            return;
        }
        ;
        this.settings = settings[this.constructor.name];
    };
    ModuleBase.prototype.SaveSettings = function () {
        settings[this.constructor.name] = this.settings;
        SaveSettings();
    };
    ModuleBase.prototype.FirstEntry = function () {
        info(this.constructor.name, 'empty FirstEntry() function');
    };
    ModuleBase.prototype.AnyEntry = function () {
        info(this.constructor.name, 'empty AnyEntry() function');
    };
    ModuleBase.prototype.SubscribeEvent = function (event, callback) {
        var s = context.subscribe(event, callback);
        this.subscriptions.push(s);
    };
    ModuleBase.prototype.UnSubscribeEvents = function () {
        for (var i in this.subscriptions) {
            this.subscriptions[i].dispose();
        }
        this.subscriptions = [];
    };
    ModuleBase.prototype.AddChange = function (key, name, from, to, factor) {
        if (factor === void 0) { factor = null; }
        var obj = { name: name, from: from, to: to, factor: factor };
        info(this.constructor.name, 'AddChange', key, JSON.stringify(obj));
        if (from === to && !factor)
            return;
        this.settings.changes[key] = obj;
        this.SaveSettings();
    };
    ModuleBase.prototype.RandomizeField = function (obj, name, difficulty) {
        if (!obj[name])
            return;
        var old = obj[name];
        obj[name] = randomize(obj[name], difficulty);
        this.AddChange(name, name, old, obj[name]);
    };
    return ModuleBase;
}());
var modules = [];
function registerModule(module) {
    info("registerModule", module.constructor.name);
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        if (m.constructor.name === module.constructor.name) {
            info("registerModule already found", module.constructor.name);
            return;
        }
    }
    modules.push(module);
}
function LoadSettings() {
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        try {
            info('LoadConfigs(): ', m.constructor.name);
            m.LoadSettings();
        }
        catch (e) {
            printException('error in LoadConfigs(): ' + m.constructor.name, e);
        }
    }
}
function FirstEntry() {
    LoadSettings();
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        try {
            info('FirstEntry(): ', m.constructor.name, m.settings.enabled);
            m.settings['changes'] = {};
            m.SaveSettings();
            if (!m.settings.enabled)
                continue;
            setLocalSeed(m.constructor.name + ' FirstEntry');
            m.FirstEntry();
        }
        catch (e) {
            printException('error in FirstEntry(): ' + m.constructor.name, e);
        }
    }
    AnyEntry(false);
}
function AnyEntry(bLoadSettings) {
    if (bLoadSettings === void 0) { bLoadSettings = true; }
    if (bLoadSettings)
        LoadSettings();
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        try {
            info('AnyEntry(): ', m.constructor.name, m.settings.enabled);
            if (!m.settings.enabled)
                continue;
            setLocalSeed(m.constructor.name + ' AnyEntry');
            m.AnyEntry();
        }
        catch (e) {
            printException('error in AnyEntry(): ' + m.constructor.name, e);
        }
    }
}
function UnSubscribeEvents() {
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        try {
            info('UnSubscribeEvents(): ', m.constructor.name);
            m.UnSubscribeEvents();
        }
        catch (e) {
            printException('error in UnSubscribeEvents(): ', m.constructor.name);
        }
    }
}
function GetModule(classname) {
    for (var i = 0; i < modules.length; i++) {
        var m = modules[i];
        if (classname === m.constructor.name) {
            return m;
        }
    }
    return null;
}
var RCTRCrowdControl = (function (_super) {
    __extends(RCTRCrowdControl, _super);
    function RCTRCrowdControl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RCTRCrowdControl.prototype.AnyEntry = function () {
        if (settings.rando_crowdcontrol) {
            init_crowdcontrol();
        }
    };
    return RCTRCrowdControl;
}(ModuleBase));
registerModule(new RCTRCrowdControl());
var cc_sock = null;
var cc_good = false;
var cc_reconnect_interval = null;
function cc_onError(hadError) {
    info('error in Crowd Control connection, will keep trying...');
    if (cc_good) {
        park.postMessage({ type: 'blank', text: 'error in Crowd Control connection, will keep trying...' });
    }
    cc_good = false;
    cc_connect();
}
function cc_onClose(hadError) {
    info('Crowd Control connection closed, will keep trying...');
    if (cc_good) {
        park.postMessage({ type: 'blank', text: 'Crowd Control connection closed, will keep trying...' });
    }
    cc_good = false;
    cc_connect();
}
function cc_onExpectedClose(hadError) {
    info('Crowd Control connection closed cc_onExpectedClose, will keep trying...');
    cc_good = true;
    cc_connect();
}
function cc_reconnect() {
    cc_connect();
}
function cc_onData(message) {
    var data = null;
    var resp = null;
    try {
        while (message[message.length - 1] == '\0')
            message = message.substring(0, message.length - 1);
        data = JSON.parse(message);
        info("Crowd Control received data: ", data);
    }
    catch (e) {
        printException('error parsing Crowd Control request JSON: ' + message, e);
    }
    try {
        resp = cc_req(data);
    }
    catch (e) {
        printException('error handling Crowd Control request: ' + message, e);
    }
    try {
        var r = JSON.stringify(resp) + '\0';
        info(message, r.length, r);
        cc_end(r);
    }
    catch (e) {
        printException('error sending Crowd Control response to: ' + message, e);
    }
}
function cc_reset_timeout() {
    if (cc_reconnect_interval !== null) {
        context.clearInterval(cc_reconnect_interval);
        cc_reconnect_interval = null;
    }
}
function cc_end(data) {
    if (!cc_sock)
        return;
    info('cc_end()');
    try {
        cc_sock.off('close', cc_onClose);
        cc_sock.on('close', cc_onExpectedClose);
    }
    catch (e) {
        printException('error closing event handlers in cc_close', e);
    }
    try {
        data = data ? data : '{"id": 0, "status": 0}\0';
        info('cc_sock.end(' + data + ')');
        cc_sock.end(data);
    }
    catch (e) {
        printException('error closing old Crowd Control connection ', e);
    }
    try {
        cc_sock.destroy(null);
    }
    catch (e) {
        printException('error destroying old Crowd Control connection ', e);
    }
    cc_reset_timeout();
    cc_good = true;
}
function cc_destroy() {
    if (!cc_sock)
        return;
    info('cc_destroy()');
    try {
        cc_sock.off('close', cc_onClose);
    }
    catch (e) {
        printException('error closing event handlers in cc_close', e);
    }
    try {
        cc_sock.off('close', cc_onExpectedClose);
    }
    catch (e) {
        printException('error closing event handlers in cc_close', e);
    }
    try {
        cc_sock.destroy(null);
    }
    catch (e) {
        printException('error destroying old Crowd Control connection ', e);
    }
    cc_sock = null;
}
function cc_connect() {
    if (network.mode == "server") {
    }
    else if (network.mode == "client") {
        return;
    }
    else {
    }
    cc_reset_timeout();
    cc_destroy();
    info('cc_connect');
    cc_sock = network.createSocket();
    cc_sock.connect(43385, '127.0.0.1', function () {
        if (!cc_good) {
            info('Crowd Control connected!');
            park.postMessage({ type: 'blank', text: 'Crowd Control connected!' });
        }
        cc_good = true;
    });
    cc_sock.setNoDelay(true);
    cc_sock.on('error', cc_onError);
    cc_sock.on('close', cc_onClose);
    cc_sock.on('data', cc_onData);
}
function init_crowdcontrol() {
    cc_connect();
    context.subscribe("guest.generation", function (e) {
        if (peepQueue.length == 0)
            return;
        var guest = map.getEntity(e.id);
        if (guest != null && guest.type == "guest") {
            context.executeAction("guestsetname", {
                peep: guest.id,
                name: peepQueue[0]
            }, noop);
            park.postMessage({
                type: "peep",
                text: peepQueue[0] + " has entered the park!",
                subject: guest.id
            });
            peepQueue.shift();
        }
    });
    context.registerAction("guestSetColor", function (args) {
        return {};
    }, function (args) {
        var guests = map.getAllEntities("guest");
        var color = args.color;
        for (var i = 0; i < guests.length; i++) {
            var guest = guests[i];
            guest.tshirtColour = color;
            guest.trousersColour = color;
        }
        return {};
    });
    context.registerAction("guestAddMoney", function (args) {
        return {};
    }, function (args) {
        var guests = map.getAllEntities("guest");
        for (var i = 0; i < guests.length; i++) {
            var guest = guests[i];
            var cash = guest.cash + args.money;
            if (cash < 0) {
                cash = 0;
            }
            else if (cash > 1000) {
                cash = 1000;
            }
            guest.cash = cash;
        }
        return {};
    });
    context.registerAction("killPlants", function (args) { return {}; }, function (args) {
        for (var y = 0; y < map.size.y; y++) {
            for (var x = 0; x < map.size.x; x++) {
                var tile = map.getTile(x, y);
                for (var i = 0; i < tile.numElements; i++) {
                    var element = tile.getElement(i);
                    if (element.type == "small_scenery") {
                        element.age = 100;
                    }
                }
            }
        }
        return {};
    });
    context.registerAction("breakThings", function (args) { return {}; }, function (args) {
        for (var y = 0; y < map.size.y; y++) {
            for (var x = 0; x < map.size.x; x++) {
                var tile = map.getTile(x, y);
                for (var i = 0; i < tile.numElements; i++) {
                    var element = tile.getElement(i);
                    if (element.type == "footpath") {
                        element.isAdditionBroken = (context.getRandom(0, 10) == 0);
                    }
                }
            }
        }
        return {};
    });
}
function cc_req(data) {
    return { id: data.id, status: handle(data) };
}
var RCTRPark = (function (_super) {
    __extends(RCTRPark, _super);
    function RCTRPark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RCTRPark.prototype.FirstEntry = function () {
        setLocalSeed('RandomizeParkFlags');
        if (settings.rando_park_flags) {
            this.RandomizeParkFlag("difficultGuestGeneration", 1);
            this.RandomizeParkFlag("difficultParkRating", 1);
            this.RandomizeParkFlag("forbidMarketingCampaigns", 1);
            this.RandomizeParkFlag("freeParkEntry", 1);
            this.RandomizeParkFlag("preferMoreIntenseRides", 1);
            this.RandomizeParkFlag("preferLessIntenseRides", -1);
            this.RandomizeParkFlag("unlockAllPrices", -1);
        }
        setLocalSeed('RandomizeParkValues');
        if (settings.rando_park_values) {
            this.RandomizeField(park, 'maxBankLoan', -1);
            this.RandomizeField(park, 'landPrice', 1);
            this.RandomizeField(park, 'constructionRightsPrice', 1);
            this.RandomizeField(park, 'cash', -1);
            this.RandomizeField(park, 'bankLoan', 1);
        }
    };
    RCTRPark.prototype.RandomizeParkFlag = function (name, difficulty) {
        var val = park.getFlag(name);
        park.setFlag(name, RngBoolWithDifficulty(difficulty));
        this.AddChange(name, name, val, park.getFlag(name));
    };
    return RCTRPark;
}(ModuleBase));
registerModule(new RCTRPark());
var RCTRRideTypes = (function (_super) {
    __extends(RCTRRideTypes, _super);
    function RCTRRideTypes() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RCTRRideTypes.prototype.FirstEntry = function () {
        for (var r in map.rides) {
            this.RandomizeRide(map.rides[r]);
        }
    };
    RCTRRideTypes.prototype.AnyEntry = function () {
        var self = this;
        self.SubscribeEvent("ride.ratings.calculate", function (ratings) {
            self.RandomizeRideCalculations(ratings);
        });
        self.SubscribeEvent("interval.day", function () {
            self.UpdateNonexistentRides();
        });
    };
    RCTRRideTypes.prototype.RandomizeRideCalculations = function (ratings) {
        if (!settings.rando_ride_types)
            return;
        var ride = map.getRide(ratings.rideId);
        if (!ride)
            return;
        var isDummy = ratings.excitement <= 0;
        var tride = isDummy ? null : ratings;
        this.RandomizeRideTypeStats(ratings.rideId, tride, ride.type, ride.classification);
    };
    RCTRRideTypes.prototype.RandomizeRide = function (ride) {
        if (!settings.rando_ride_types)
            return;
        if (!ride)
            return;
        this.RandomizeRideTypeStats(ride.Id, ride, ride.type, ride.classification);
    };
    RCTRRideTypes.prototype.UpdateNonexistentRides = function () {
        var existingRideTypes = {};
        for (var r in map.rides) {
            var ride = map.rides[r];
            var type = ride.type;
            existingRideTypes[type] = 1;
            this.SetRideTypeSeed(ride.type, 'runningCost');
        }
        for (var c in this.settings.changes) {
            var m = c.match(/ride:(\d+):(.+)/);
            if (!m)
                continue;
            var type = parseInt(m[1]);
            var field = m[2];
            if (existingRideTypes[type])
                continue;
            existingRideTypes[type] = 1;
            var change_name = this.settings.changes[c].name;
            var rideTypeName = change_name.replace(' ' + field, '');
            this.RandomizeRideTypeStats(null, null, type, 'ride');
        }
    };
    RCTRRideTypes.prototype.RandomizeRideTypeStats = function (rideId, ride, rideTypeId, classification) {
        var changed = false;
        var isIntense = true;
        var rideTypeName = this.GetRideTypeName(rideTypeId);
        var isRide = (classification == 'ride');
        if (isRide) {
            this.SetRideTypeSeed(rideTypeId, 'ride');
            changed = this.RandomizeRideTypeField(ride, rideTypeName, rideTypeId, 'excitement', -1) || changed;
            changed = this.RandomizeRideTypeField(ride, rideTypeName, rideTypeId, 'intensity', 0, isIntense ? 0.5 : 1.0) || changed;
            changed = this.RandomizeRideTypeField(ride, rideTypeName, rideTypeId, 'nausea', -1, 0.7) || changed;
        }
        this.SetRideTypeSeed(rideTypeId, 'runningCost');
        if (changed && rideId) {
            park.postMessage({ type: 'attraction', text: rideTypeName + ' stats have been re-rolled', subject: rideId });
        }
        else if (changed) {
            park.postMessage({ type: 'attraction', text: rideTypeName + ' stats have been re-rolled' });
        }
        return changed;
    };
    RCTRRideTypes.prototype.SetRideTypeSeed = function (rideTypeId, salt) {
        setLocalSeed('RandomizeRide cycle ' + rideTypeId);
        var cycle = 0;
        if (settings.num_months_cycle) {
            var rand_cycle = rng(0, settings.num_months_cycle * 1000);
            cycle = Math.floor((rand_cycle + date.monthsElapsed) / settings.num_months_cycle);
        }
        cycle += settings.cycle_offset;
        setLocalSeed('RandomizeRide ' + rideTypeId + ' ' + cycle + salt);
    };
    RCTRRideTypes.prototype.RandomizeRideTypeField = function (ride, rideTypeName, rideTypeId, name, difficulty, wetdry) {
        if (wetdry === void 0) { wetdry = 1; }
        var type = rideTypeId;
        var factor = randomize(1, difficulty);
        var dry = 1 - wetdry;
        factor = (factor * wetdry) + (1 * dry);
        if (ride && ride[name])
            ride[name] *= factor;
        var key_name = 'ride:' + type + ':' + name;
        var old_change = this.settings.changes[key_name];
        if (!settings.rando_scouting && !ride && !old_change) {
            return false;
        }
        if (!old_change || old_change.factor.toFixed(5) !== factor.toFixed(5)) {
            this.AddChange(key_name, rideTypeName + ' ' + name, null, null, factor);
            return old_change;
        }
        return false;
    };
    RCTRRideTypes.prototype.GetRideTypeName = function (id) {
        if (!RideType[id]) {
            return id.toString();
        }
        return RideType[id];
    };
    return RCTRRideTypes;
}(ModuleBase));
registerModule(new RCTRRideTypes());
var RCTRScenario = (function (_super) {
    __extends(RCTRScenario, _super);
    function RCTRScenario() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RCTRScenario.prototype.FirstEntry = function () {
        setLocalSeed('RandomizeScenarioLength');
        if (Math.abs(settings.scenarioLength) < 0.1) {
            settings.scenarioLength = rng(50, 300) / 100;
        }
        info('scenario.objective.year: ', scenario.objective.year, ', scenarioLength: ' + settings.scenarioLength);
        if (scenario.objective.year) {
            var old = scenario.objective.year;
            scenario.objective.year = Math.ceil(scenario.objective.year * settings.scenarioLength);
            this.AddChange('objective.year', 'Objective Year', old, scenario.objective.year);
        }
        else {
            settings.scenarioLength = 1;
        }
        setLocalSeed('RandomizeScenarioGoals');
        this.RandomizeObjective('guests', 1, 0.9);
        this.RandomizeObjective('excitement', 1, 0.3);
        this.RandomizeObjective('monthlyIncome', 0.9);
        this.RandomizeObjective('parkValue', 0.9);
        info(scenario.objective);
    };
    RCTRScenario.prototype.RandomizeObjective = function (name, difficulty, scenarioLengthExp) {
        if (scenarioLengthExp === void 0) { scenarioLengthExp = 1; }
        if (!scenario.objective[name])
            return;
        var old = scenario.objective[name];
        if (settings.rando_goals) {
            scenario.objective[name] = randomize(scenario.objective[name], difficulty) * (Math.pow(settings.scenarioLength, scenarioLengthExp));
        }
        else {
            scenario.objective[name] *= (Math.pow(settings.scenarioLength, scenarioLengthExp));
        }
        this.AddChange(name, 'Objective ' + name, old, scenario.objective[name]);
    };
    return RCTRScenario;
}(ModuleBase));
registerModule(new RCTRScenario());
